<?php
declare (strict_types = 1);

namespace app\common\model;

use think\Model;
use think\model\concern\SoftDelete;
class YpayOrder extends Model
{
    use SoftDelete;
     protected $deleteTime = "delete_time";
    // 获取列表
    public static function getList()
    {
        $where = [];
        $limit = input('get.limit');
        
               //按状态查询
               $status = input("status");
               if ($status !="" && $status!=null) {
                   $where[] = ["status", "=",$status];
               }
               //按账号ID查找
               if ($account_id = input("account_id")) {
                   $where[] = ["account_id", "like", "%" . $account_id . "%"];
               }
               //按商户单号查找
               if ($trade_no = input("trade_no")) {
                   $where[] = ["trade_no", "like", "%" . $trade_no . "%"];
               }
               //按本地单号查找
               if ($out_trade_no = input("out_trade_no")) {
                   $where[] = ["out_trade_no", "like", "%" . $out_trade_no . "%"];
               }
               //按会员ID查找
               if ($user_id = input("user_id")) {
                   $where[] = ["user_id", "like", "%" . $user_id . "%"];
               }
        $list = self::order('id','desc')->where($where)->paginate($limit);
        return ['code'=>0,'data'=>$list->items(),'extend'=>['count' => $list->total(), 'limit' => $limit]];
    }
    
    public static function getUserList($user_id)
    {
        $where = [];
        $limit = input('get.limit');
               //按账号ID查找
               if ($account_id = input("account_id")) {
                   $where[] = ["account_id", "like", "%" . $account_id . "%"];
               }
               //按本地单号查找
               if ($out_trade_no = input("out_trade_no")) {
                   $where[] = ["out_trade_no", "like", "%" . $out_trade_no . "%"];
               }
               if (input("state")!= "k" && input("state")!=""  ) {
                   $sta = input("state");
                   $where[] = ["status", "=",$sta];
               }
               $start = input("get.startDate");
               $end = input("get.endDate");
               if ($start && $end) {
                   $where[]=["create_time","between",[$start,date("Y-m-d",strtotime("$end +1 day"))]];
               }
               //按会员ID查找
               $where[] = ["user_id", "=", $user_id];
        $list = self::order('id','desc')->where($where)->paginate($limit);
        return ['code'=>0,'data'=>$list->items(),'extend'=>['count' => $list->total(), 'limit' => $limit]];
    }
    
    
}
